import psycopg2
from get_config import database


def init(app):
    app.on_startup.append(init_pg)
    app.on_cleanup.append(close_pg)


def init_pg(app):
    app['db'] = psycopg2.connect(
        host=database["host"],
        port=database["port"],
        dbname=database["database"],
        user=database["user"],
        password=database["password"]
    )


def close_pg(app):
    app['db'].close()
