#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
#  
#  Copyright 2017-2018 krasytod <krasytod@gmail.com>
###
'''
alter table client add column did_fixed_fees_last_payment timestamp with time zone default null ;


'''
import types
import psycopg2
import psycopg2.extras
import datetime,time,calendar
from decimal import *
import configparser,argparse,traceback
import logging,os,sys,signal , requests
from logging.handlers import TimedRotatingFileHandler
from logging.handlers import RotatingFileHandler
from dateutil.relativedelta import relativedelta

from lockfile.pidlockfile import PIDLockFile
from lockfile import AlreadyLocked
import smtplib,requests, multiprocessing,signal,base64 , subprocess
from email.mime.multipart import MIMEMultipart
from email.mime.base import MIMEBase
from email.mime.text import MIMEText
from email.utils import COMMASPACE, formatdate
from email import encoders
from get_config import AUTOINVOICE as AUTOINVOICE_config
from get_config import port as server_port
from get_config import database
import sql_signatures

config = ''
#pidfile = ''

VERSION = {'ver':"0.1.31",'date':'2018-01-24'}

logger = logging.getLogger('DID Auto invoice')

FTP_HOST = ""


class GracefulKiller:
	def __init__(self,proc,logger):
		signal.signal(signal.SIGINT, self.exit_gracefully)
		signal.signal(signal.SIGTERM, self.exit_gracefully)
		#self.proc = proc
		self.logger = logger
	def exit_gracefully(self,signum, frame):
		self.logger.debug ("Daemon is exiting")
		#print ("Information from proccess cout %s"  % outs)
		#print ("Information from proccess cerr %s"  % errs)
		#self.logger.debug ("Information from DID invoice API on exiting.  cout: %s  cerr: %s"   % (outs,errs)  )
		exit (0)


''' 
On an hourly basis, run the following:
- select all client that meets the following:
1. Has more than 1 ingress resource - select count(*) from resource where client_id = xxx
2. Is active - select active from client where client_id = xxx
3 has invoice_flag turned on
4 has a invoice payment_term specified in the payment_term_field. payment term can be associated with payment_term table'''

billing_type= {1:"Invoice every XX days",2: 'Inovice once a month on a specific day',3:'Invoice once a week on a specific day of week',4:'invoice multiple times a month on a specific day(s) of month'}
DAYS_OF_WEEK = {0:"Sunday new style",1:"Monday",2:"Tuesday",3:"Wednesday",4:"Thursday",5:"Friday",6:"Saturday",7:"Sunday"}


INVOICE_SQL ='''select client.client_id ,   client.name as client_name ,extract('epoch' from current_date) as now_date, * FROM  client  WHERE Client.client_type = '1' and   ( select count(*) from 
resource where resource.client_id = client.client_id  and resource.egress='t'  ) > 0  and client.auto_invoicing  is true ;'''


INVOICE_COUNT_SQL = '''select resource.client_id,count(resource.ingress is true) from resource join 
client on resource.client_id=client.client_id group by resource.client_id having 
count(resource.ingress is true) > 0  ;
'''


PAYMENT_TERM_SQL = " select * from payment_term"

SWITCH_INVOICE_SETTINGS = '''SELECT invoice_name, tpl_number, pdf_tpl, company_info,overlap_invoice_protection,send_cdr_fields, invoice_send_mode,company_info_location,invoice_decimal_digits
 FROM system_parameter'''


def startDid(port= 18881,host = '0.0.0.0'):
	dir_path = os.path.dirname(os.path.realpath(__file__))
	run_file =dir_path+"/server.py"
	port = "-l %s"%port
	port = port.strip().replace("\n","")
	host = "-j %s"%host
	host = host.strip().replace("\n","")

	args = ["python3",run_file   ]
	
	print (args)
	proc = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=subprocess.PIPE,shell=True)

	
	return proc



def get_system_parameter(cur):
	sql = """select * from system_parameter limit 1"""
	cur.execute(sql)
	return cur.fetchone()


def connect_to_postgresql(host, port, database, user, password=None):
	try:
		conn = psycopg2.connect(host=host, port=port, database=database, user=user, password=password)
		conn.autocommit = True
		cursor = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
		print("connected to DB")
	except Exception as e: 
		print (" Exception in DB connecting:  %s" % (str(e) ) )
		raise 'I am unable to connect to the PostgreSQL. %s'% (str(e))
	return conn, cursor




def setTimeZone(time_zone):
	sign = time_zone[0]
	hour = int(time_zone[1:3] )
	mins = int(time_zone[4:] )
	mins = (10/6) * mins
	if sign == "+":
		hour = hour
	else:
		hour = -1 * hour
	
	return hour

def checkClients(result,client_dict,total_invoices,pg_cur):
	invoices_needed= []
	for client in client_dict:
		print (client.keys())
		try:
			sql = ''' select sys_timezone from system_parameter offset 0 limit 1 ; '''
			pg_cur.execute(sql)
			time_zone = pg_cur.fetchone().get('sys_timezone','+00:00')
			time_zone = setTimeZone (time_zone)  #(client.get('invoice_zone', "+00:00"))
		except Exception as e:
			print("Do not get time zone for client auto invoice. setting to GMT %s" %e)
			logger.debug("Do not get time zone for client auto invoice. setting to GMT %s"%e)
			time_zone = 0
		try:
			client["name"] =client["client_name"]
		except:
			print ("Client do not have client name or paymenter term")
			continue
		
		print ( "Client to be cheched ",client["name"],client["client_id"] )
		if client['type'] == None:
			logger.debug ( "Client do not have paymenter term  %s ID %s and payment type: %s"% ( client["name"],client['client_id'],client['type'])  )
			print  ( "Client do not have paymenter term  %s ID %s and payment type: %s"% ( client["name"],client['client_id'],client['type'])  )
			continue
		logger.debug ( "Client to be cheched name %s ID %s and payment type: %s"% ( client["name"],client['client_id'],client['type'])  )

		
		sql_mod = None
		#print(client['last_invoiced'])
		client_invoice_history_sql = "select last_invoice_for,extract('epoch' from last_invoice_for) as last_invoice_for_epoch from invoice_history where client_id = %s order by last_invoice_for desc limit 1" % (client['client_id'])
		pg_cur.execute(client_invoice_history_sql)
		invoice_history =pg_cur.fetchone()
		last_invoiced   = client['last_invoiced'] 
		#print (invoice_history,last_invoiced)
		if last_invoiced == None:
			print ("Never Invoiced")
			logger.debug ("Client %s with Id:  %s is type %s is never invoiced before " % (client['name'],client['client_id'],billing_type[client['type']]))
			last_invoiced   = client['create_time'] - datetime.timedelta(weeks=100)

		invoice_start_from  =  int(last_invoiced.timestamp())
		
		if  client['type'] == 1: # Every Nth day
			print ("Every Nth day")
			logger.debug("Every Nth day")
			send_epoch =invoice_start_from +24 * 3600 * client['days']
			print (last_invoiced.date() == datetime.datetime.today().date()  ,last_invoiced.date() ,datetime.datetime.today().date())
			end_epoch =invoice_start_from +24 * 3600 *( client['days'] - 1)  # end of billing period invoice is one day before send date
			print("Last invoice: %s Send: %s  Now: %s  End of billing period: %s" % ( last_invoiced ,str(send_epoch), str( client['now_date']),end_epoch )  ) 
			logger.debug("Last invoice: %s Send: %s  Now: %s  End of billing period: %s" % ( last_invoiced ,str(send_epoch), str( client['now_date']),end_epoch )  ) 
			if   last_invoiced.date() <  datetime.datetime.today().date(): # and  invoice_start_from < send_epoch  :  # send_epoch <= client['now_date']  and
				today = datetime.date.today()
				send_datetime = today #. replace(day=client_days) #same year, month  but the day is changed 
				send_epoch = calendar.timegm(send_datetime.timetuple())
				send_epoch_str = datetime.datetime.utcfromtimestamp(send_epoch) 
				end_timestamp =time.strftime("%Y-%m-%d",  time.gmtime(send_epoch))
				invoice_end_time = send_datetime  + datetime.timedelta(days=-1) 
				invoice_start_time = send_datetime + datetime.timedelta(days=-client['days'])   #  datetime.timedelta(months=-1)  # send_datetime.replace(day=1)
				# update invoice log
				end_timestamp =time.strftime("%Y-%m-%d",  time.gmtime(send_epoch))
				#invoice_start_time = str(invoice_start_time)  + " 00:00:00"
				#invoice_end_time = str(invoice_end_time) + " 23:59:59" 
				sql_mod = "INSERT INTO invoice_history(last_invoice_for,client_id) values(%s,%s)" % (send_epoch,client['client_id'])
				#pg_cur.execute(sql_mod)
				#report = pg_cur.fetchall()
				#print (report)
				total_invoices = total_invoices+1
				print ( """ New Invoice for client %s , from: %s, To: %s """ % ( client, invoice_start_time,invoice_end_time )   )
				logger.debug( """ New Invoice for client %s , from: %s, To: %s """ % ( client, invoice_start_time,invoice_end_time )   )
				invoices_needed.append([client, invoice_start_time,invoice_end_time])
			else:  #no invoice
				print("No Invoice For client %s with Id %s with billing every %s-th day, Last invoice: %s   Now: %s  End of billing period: %s" % (client['name'],client['client_id'],client['days'], last_invoiced ,
time.strftime('%Y-%m-%d', time.localtime(client['now_date'])),time.strftime('%Y-%m-%d', time.localtime( end_epoch) ) )  )
				logger.debug("No Invoice For client %s with Id %s with billing every %s-th day, Last invoice: %s   Now: %s  End of billing period: %s" % (client['name'],client['client_id'],client['days'], last_invoiced ,
time.strftime('%Y-%m-%d', time.localtime(client['now_date'])),time.strftime('%Y-%m-%d', time.localtime( end_epoch) ) )  )
		#- if it is weekly, then we check the day of week , the invoice should be generated from the last week’s till end of yesterday
		if  client['type'] ==2: #  # Day of month  
			print ("type: Month ")
			today =   datetime.datetime.now() + datetime.timedelta(hours=time_zone)     #datetime.date.today() +  datetime.timedelta(days=-7)
			client_days = client['days'] #which day
			send_datetime = today #.replace(day=client_days) #same year, month  but the day is changed 
			send_epoch = calendar.timegm(send_datetime.timetuple())
			send_epoch_str = datetime.datetime.utcfromtimestamp(send_epoch) 
			end_timestamp =time.strftime("%Y-%m-%d",  time.gmtime(send_epoch))
			invoice_end_time = send_datetime + datetime.timedelta(days=-1) 
			invoice_start_time = today.replace(day=1)    #  datetime.timedelta(months=-1)  # send_datetime.replace(day=1)
			print ("invoice_start_time",invoice_start_time,invoice_end_time,relativedelta(months=-1))
			print ("Today is %s" % today.day,today.day == client['days']  )
			print (today , invoice_start_from   , today.timestamp()- invoice_start_from, type(last_invoiced) ,  time.strftime('%Y-%m-%d', time.localtime(client['now_date'])))
			#strftime("%Y-%m-%d 23:59:59");
			#invoice_start_time = str(invoice_start_time)  + " 00:00:00"
			#invoice_end_time = str(invoice_end_time) + " 23:59:59" 
			if today.day == client['days'] and  last_invoiced.day !=today.day : #int( today.timestamp() - invoice_start_from) > 24 * 3601): #  or client['days'] == 28:
				end_timestamp = str(send_datetime)
				sql_mod = "INSERT INTO invoice_history(last_invoice_for,client_id) values(%s,%s)" % (send_epoch,client['client_id'])
				#pg_cur.execute(sql_mod)
				
				total_invoices = total_invoices+1
				#if client ['invoice_start_from'] != None:
				#	invoice_start_time = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(client ['invoice_start_from']) ) 
				invoices_needed.append([client, invoice_start_time,invoice_end_time])
				logger.debug("New once in month invoice For client %s with Id %s with billing at %s-th day, Last invoice: %s   Now: %s , Invoice start date: %s, Invoice end date %s" % ((client['name'],client['client_id'],client['days'], last_invoiced ,  time.strftime('%Y-%m-%d ', time.localtime(client['now_date'])),invoice_start_time,invoice_end_time )  ))
				print("New once in month invoice For client %s with Id %s with billing at %s-th day, Last invoice: %s   Now: %s , Invoice start date: %s, Invoice end date %s" % ((client['name'],client['client_id'],client['days'], last_invoiced ,  time.strftime('%Y-%m-%d ', time.localtime(client['now_date'])),invoice_start_time,invoice_end_time )  ))
			else:
				print("No new once in month invoice For client %s with Id %s with billing at %s-th day, Last invoice: %s   Now: %s " % (client['name'],client['client_id'],client['days'], last_invoiced ,  time.strftime('%Y-%m-%d', time.localtime(client['now_date'])) ))
				
				
		elif  client['type'] == 3:  # Day of Week
			print ("Day of Week")
			logger.debug("Day of Week")   
			today =   datetime.datetime.now() + datetime.timedelta(hours=time_zone) 
			#today = datetime.date.fromtimestamp(time.time() + datetime.timedelta(hours=time_zone)  )    #today = datetime.date.today()  #+ datetime.timedelta(days=-2)   date.fromtimestamp(time.time())
			day_of_week = today.weekday() +1   #monday is zero in Python!!!
			if day_of_week == 7:  #Sunday!
				day_of_week = 0 
			diff =client['days'] - day_of_week
			print (client['days'],day_of_week )
			logger.debug("invoice_start_from %s"%invoice_start_from)
			print("invoice_start_from %s"%invoice_start_from)
			print ("diff" ,diff , time.mktime(today.timetuple()) , invoice_start_from,client['now_date']- invoice_start_from )
			print ()
			if diff == 0  and  int(time.mktime(today.timetuple()) - invoice_start_from) > 24 * 3601 : # if not same day of week, Skip!! Also the diff in seconds between now and last invoice must be bigger from 24 * 3601(a day)
				client_days = client['days'] #which day of week
				send_epoch = calendar.timegm(today.timetuple())
				send_epoch_str = datetime.datetime.utcfromtimestamp(send_epoch)
				end_timestamp =time.strftime("%Y-%m-%d",  time.gmtime(send_epoch))
				today = datetime.date.today()  #+ datetime.timedelta(days=-2)
				invoice_start_time = today + datetime.timedelta(days=-7)     #str(last_invoiced) 
				invoice_end_time =today + datetime.timedelta(days=-1) 
				sql_mod = "INSERT INTO invoice_history(last_invoice_for,client_id) values(%s,%s)" % (send_epoch,client['client_id'])
				#pg_cur.execute(sql_mod)
				total_invoices = total_invoices+1
				invoices_needed.append([client, invoice_start_time,invoice_end_time])
				print("For client with id %s ,with billing: Day of week: %s. New Invoiced is made.Last invoice was at: %s .Today  is %s,  %s" % ( client['client_id'],
				DAYS_OF_WEEK[client['days']],invoice_start_time,DAYS_OF_WEEK[day_of_week], time.strftime("%Y-%m-%d", time.gmtime( client['now_date']) )  ) ) 
				logger.debug("For client with id %s ,with billing: Day of week: %s. New Invoiced is made.Last invoice was at: %s .Today  is %s,  %s" % ( client['client_id'],DAYS_OF_WEEK[client['days']],invoice_start_time,DAYS_OF_WEEK[day_of_week], time.strftime("%Y-%m-%d", time.gmtime( client['now_date']) )  ) ) 
				#Make Invoice!
			else:  #NO invoice!
				print("For client with id %s ,with billing: Day of week: %s. New Invoiced is not neeeded now.Last invoice was at: %s .Today is %s, %s" % ( client['client_id'],DAYS_OF_WEEK[client['days']],client['last_invoiced'], DAYS_OF_WEEK[day_of_week],time.strftime("%Y-%m-%d", time.gmtime( client['now_date']) )  ) ) 
				logger.debug("For client with id %s ,with billing: Day of week: %s. New Invoiced is not neeeded now.Last invoice was at: %s .Today is %s, %s" % ( client['client_id'],DAYS_OF_WEEK[client['days']],client['last_invoiced'], DAYS_OF_WEEK[day_of_week],time.strftime("%Y-%m-%d", time.gmtime( client['now_date']) )  ) ) 
				
		elif  client['type'] == 4:  # Some Day of month
			payment_days = client['more_days'].split(",")
			today = datetime.date.today()
			today_now =   datetime.datetime.now() + datetime.timedelta(hours=time_zone)
			invoice_end_time =today + datetime.timedelta(days=-1)  
			invoice_start_time =   today + relativedelta(months=-1)   #str(last_invoiced) datetime.timedelta(months=-1)
			invoice_end_time = invoice_end_time
			Make_invoice  = False
			for day in payment_days:
				print (today.day,type(today.day),day,type(day)  )
				logger.debug("Today: %s, Payment Day %s" % (str(today.day),str(day)))
				if int(today.day) == int(day):
					if int(time.mktime(today_now.timetuple()) - invoice_start_from) > 24 * 3601 : # if not same day of week, Skip!! Also the diff in seconds between now and last invoice must be bigger from 24 * 3601(a day)
						Make_invoice  = True
						break
			if Make_invoice  == True:
				print("For client_id %s billing type : Days of month: %s . New Invoice is created. From: %s , To: %s .Last invoice was at: %s .Today is %s" % ( client['client_id'],payment_days,invoice_start_time,invoice_end_time,last_invoiced ,time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(client['now_date']))  ) ) 
				logger.debug("For client_id %s billing type : Days of month: %s . New Invoice is created. From: %s , To: %s .Last invoice was at: %s .Today is %s" % ( client['client_id'],payment_days,invoice_start_time,invoice_end_time,last_invoiced ,time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(client['now_date']))  ) ) 
				send_epoch = calendar.timegm(today.timetuple())
				send_epoch_str = datetime.datetime.utcfromtimestamp(send_epoch)
				end_timestamp =time.strftime("%Y-%m-%d",  time.gmtime(send_epoch))
				total_invoices = total_invoices+1
				invoices_needed.append([client, invoice_start_time,invoice_end_time])
				sql_mod = "INSERT INTO invoice_history(last_invoice_for,client_id) values(%s,%s)" % (send_epoch,client['client_id'])
				#pg_cur.execute(sql_mod)
			else:
				logger.debug("For client_id %s billing type : Days of month: %s . Invoice is not created. Today is %s" % ( client['client_id'],payment_days,time.strftime('%Y-%m-%d', time.localtime(client['now_date']))  ) ) 
				print("For client_id %s billing type : Days of month: %s . Invoice is not created. Today is %s" % ( client['client_id'],payment_days,time.strftime('%Y-%m-%d', time.localtime(client['now_date']))  ) ) 
				
		if sql_mod != None:
			print("Updating DB invoice history with SQL: %s"% (sql_mod))

	return (total_invoices, invoices_needed)

def get_invoice_no(pg_cur):
    ''' Gets new No for invoice'''
    get_number_sql = "SELECT nextval('class4_seq_invoice_no'::regclass) as no;"
    # изключено заради теста , нямам достъп до базата данни !
    try:
     pg_cur.execute(get_number_sql)
     result_id =pg_cur.fetchone() 
     new_id = result_id['no']
    except Exception as e: 
     print(" Exception in Getting invoice num:  %s" % (str(e) ) )
     logger.error (" Exception in Getting invoice num:  %s" % (str(e) ) )
    ###exist_no_sql = "select invoice_number as no from invoice where invoice_number='$get_number' limit 1 " %s
    ###v stariq code ima proverka dali ne se izpolsva ?!??! "select invoice_number as no from invoice where invoice_number='$get_number' limit 1 " Warning 01
    #new_id = 13
    return new_id;


def get_smtp_info(cursor):
	sql = """SELECT smtphost as host,smtpport as port,emailusername as username,emailpassword as password,loginemail as is_auth,fromemail as from_email, smtp_secure as smtp_secure,noc_email as noc_email ,switch_alias FROM system_parameter LIMIT 1"""
	cursor.execute(sql)
	smtp_setting = cursor.fetchone()
	return smtp_setting

def GetEmailTemplate(cursor):
	sql = """select invoice_from ,invoice_to ,invoice_cc ,invoice_subject ,invoice_content from mail_tmplate limit 1 ;"""
	print (sql)
	try:
		cursor.execute(sql)
		email_template  =cursor.fetchone() 
	except Exception as e: 
		logger.error (" Exception in getting EmailTemplate:  %s" % (str(e) ) )
		print (" Exception in getting EmailTemplate:  %s" % (str(e) ) )
		return -1
	return email_template


def send_mail( send_from, invoice_cc, send_to, subject, text, files, server, port, username, password, smtp_info,isTls=False):
    #send_to = "piyali@intlcx.com;anne.denovolab@gmail.com;krasytod@gmail.com"
    msg = MIMEMultipart()
    msg['From'] = send_from
    msg['To'] = send_to  #COMMASPACE.join(send_to)
    msg['cc'] = invoice_cc
    msg['Date'] = formatdate(localtime = True)
    msg['Subject'] = subject
    msg.attach( MIMEText(text, 'html') )
    if smtp_info['smtp_secure'] == 1:
     isTls=True
    else:
     isTls=False
    for f in files:
        #print ("f:",f)
        try:
          #f = 'app/invoice/'+f
          pass
        except Exception as e: 
          logger.error (" Exception in generating file list for email:  %s" % (str(e) ) )
          print (" Exception in generating file list for email:  %s" % (str(e) ) )
          continue
        part = MIMEBase('application', "octet-stream")
        part.set_payload( open(f,"rb").read() )
        encoders.encode_base64(part)
        part.add_header('Content-Disposition', 'attachment; filename="{0}"'.format(os.path.basename(f)))
        msg.attach(part)
    send_to = send_to.split(";")  +invoice_cc.split(";")
    
    print ("send_to 3",send_to, type(send_to))
    print ("smtp_info['smtp_secure']",smtp_info['smtp_secure'] ,server, port,smtp_info['username'], smtp_info['password'] )
    #print ("msg: ",msg) 
    if smtp_info['smtp_secure'] == 2:
       smtp = smtplib.SMTP_SSL(server, port)
       #smtp = smtplib.SMTP(server, port)
    else:
       smtp = smtplib.SMTP(server, port)
    try:   
        smtp.set_debuglevel(True)
        if isTls: smtp.starttls() 
        smtp.ehlo()
        smtp.login(smtp_info['username'], smtp_info['password'])
        smtp.sendmail(smtp_info['from_email'], send_to, msg.as_string())

    except smtplib.SMTPRecipientsRefused:
        logger.error( 'All recipients were refused.')
    except smtplib.SMTPHeloError:
        logger.error( 'The server didn’t reply properly to the HELO greeting.')
    except smtplib.SMTPSenderRefused:
        logger.error( 'The server didn’t accept the %s.' % smtp_info['from_email'] )
    except smtplib.SMTPDataError:
        logger.error( 'The server replied with an unexpected error code (other than a refusal of a recipient).' )
    else:
        logger.debug( 'OK' )
    finally:
        try:
         smtp.quit()
        except:
         pass


def GetCdrFields(pg_cur):
	
	sql = '''SELECT send_cdr_fields as fields  FROM system_parameter LIMIT 1;''' # gets cdr link fields
	print ("Getting send_cdr_fields from Sysytem parameter: %s" % sql)
	try:
		pg_cur.execute(sql)
		fields = pg_cur.fetchone()
	except Exception as e: 
		print (" Exception in getting send_cdr_fields from Sysytem parameter:  %s" % (str(e) ) )
		logger.error("Exception in getting send_cdr_fields from Sysytem parameter:  %s" % (str(e) ) )
		return []
	print ("Returned result from query for getting send cdr fields:", fields)
	# change comma delimiter to "&nbsp;"
	#fields =fields['fields'].replace( ',',',&nbsp;' )
	
	return fields['fields']

def GetCdrLink(client,pg_cur,data,fields):
	url = config['cdr']["url"]
	get_url = config['cdr']["get_cdr"]
	switch = config['cdr']["switch"]
	start = str( data['start_date'] )
	end = str( data['end_date'] )
	headers = {'Content-Type': 'application/json',}
	#end = "2017-01-02 23:59:59"
	jsn_request = {"switch_ip" : switch,"start" : start,"end" : end,
	"search_filter" : "ingress_client_id=%s" % client['client_id']  , "result_filter" : "%s" % fields }  #   % 258   
	print ("json_request",jsn_request)
	r= requests.post(url  ,json= jsn_request ) 
	cdr_links = []
	
	if  int (r.status_code) == 200:
		data = r.json()
		
		counter = len (data['query_key'])
		counter_end = counter * 20
		print ("Getting CDR Info with length", counter)
		time.sleep (counter)
		for key in data['query_key']:
			payload = {"query_key": key,"switch_ip" :switch  }
			print ("payload: ", payload)
			r = requests.post(get_url , json=payload ,headers= headers)
			#print (r.url)
			print (counter_end )
			if counter_end == 0 :
				print("too long time API do not respond")
				logger.debug("too long time API do not respond")
				return cdr_links
			try:
				result = r.json()['query'][0]
				if result['status'] != None:
					counter =counter-1
					print (counter)
					if result['url'] != None:
						cdr_links.append(result)
				else:
					print ("No result for: ",result['status'],result['url'] )
					data['query_key'].append(key)
					time.sleep (1)
				counter_end -=1
			except: 
				counter_end -=1
				
	return cdr_links
	
def send_email_log( client,send_to,mail_subject, mail_content, files,pg_cur):
	sql = """insert into email_log(send_time,client_id,email_addresses,files ,type,subject,content ) values (CURRENT_TIMESTAMP(0),%s, %s ,%s, %s,%s, %s)"""
	## email log still do not work!
	print ("Email log send_to ", send_to,"files ",files) 
	pg_cur.execute(sql, (client['client_id'],str(send_to) ,files , 7,mail_subject, mail_content))
	
def email_invoice(filename, client,pg_cur,smtp_info,EmailTemplate,subject = "New Invoice for %s"):
	'''Sends email with invoice or link to invoice with given filename'''
	print (type(client),type(smtp_info),type(EmailTemplate))
	pg_cur = None
	try:
		pg_conn, pg_cur = connect_to_postgresql(database["host"],int(database ["port"]), database ["database"], database ["user"],database ["password"]) #config ["password"]
	except Exception as e: 
		print (" Exception in connect_to_postgresql Invoice email:  %s" % (str(e) ) )
		logger.error(" Exception in connect_to_postgresql Invoice email:  %s" % (str(e) ) )
		return -1
	
	ftp = config["other"]["ftp"]
	
	##CDR link
	if False : #client.get('is_link_cdr',False):
		try:
			cdr_link = GetCdrLink(client,pg_cur,data,fields)
			#cdr_exception = False
		except Exception as e:
			print("exception is getting cdr links %s"%e)
			logger.error("exception is getting cdr links %s"%e)
			cdr_link = []
			#cdr_exception = True
		print ("cdr_links",cdr_link)
	else:
		print("No is_link_cdr ")
		cdr_link  = []
	
	links_cdr = ""
	for elem in cdr_link:
		
		print (elem)
		links_cdr = links_cdr + "<a href='%s'>CDR LINK for %s - %s </a>  <br>" % (  elem['url'],elem['start'],elem['finish']  )
	print (EmailTemplate,type(EmailTemplate))
	logger.debug(smtp_info)
	mail_subject =  str ( EmailTemplate.get('invoice_subject',"N/A") )   #subject % ( client.get("client_name",client.get("name","N/A") ) )
	server =  smtp_info['host']
	port = smtp_info['port'] 
	username = smtp_info['username']
	password = smtp_info['password'] 
	
	if EmailTemplate.get('invoice_from',"default").strip() == "default":
		send_from  = smtp_info['from_email'] 
	else:
		send_from  = EmailTemplate.get('invoice_from',1)
		sql  = """select * from mail_sender where id = %s""" % send_from
		pg_cur.execute(sql)
		send_from = pg_cur.fetchone() 
		try:
			send_from = send_from['name']
		except:
			send_from = "N/A"
	invoice_cc = EmailTemplate.get('invoice_cc',"")
	send_to = client['email']#  .split(";")
	#send_to = "piyali@intlcx.com;anne.denovolab@gmail.com;krasytod@gmail.com" 
	if len (send_to ) ==0 :
		print ('client %s  email is not configured' % client["client_name"])
		logger.error ('client %s  email is not configured' % client['client_name'])
		return -1
	if smtp_info['smtp_secure'] == 1:
		isTls=True
	else:
		isTls=False
	#print ('is_send_as_link', client['is_send_as_link']  )
	
	sys_params = get_system_parameter(pg_cur)
	
	if sys_params['invoice_send_mode'] == 1:
		sql = "select invoice_number ,total_amount from orig_invoice where client_id = '%s'  order by invoice_id desc limit 1"%client['client_id']
		print (sql)
		try:
			
			pg_cur.execute(sql)
			result = pg_cur.fetchone()
			invoice_number =result ['invoice_number']
			total_amount = result['total_amount']
			files = []
			#base64_encode = base64.b64encode(bytes(str(invoice_id), 'utf-8'))                   #int(invoice_number).to_bytes(2, byteorder='big')
			#print ("invoice_number",invoice_number,"FTP_HOST",FTP_HOST,"base64_encode",base64_encode.decode() )
			links_pdf =  "<a href = '%s/%s' > Download Invoice here </a> <br>" %  ( ftp,invoice_number)
		except Exception as e: 
			print (" Exception in getting  invoice_id:  %s" % (str(e) ) )
			logger.error("Exception in invoice_id :  %s" % (str(e) ) )
			links_pdf =  "Link to your invoice can`t be uptain. Please contact the support" 
			files = []
			invoice_number ="N/A"
			total_amount = "N/A"
	else:
		'''try:
			sql = "select invoice_id ,total_amount from invoice where invoice_number = '%s'"%invoice_number
			pg_cur.execute(sql)
			invoice_id = pg_cur.fetchone()['invoice_id']
			total_amount = pg_cur.fetchone()['total_amount']
		except Exception as e: 
			print (" Exception in getting  invoice_id:  %s" % (str(e) ) )
			logger.error("Exception in invoice_id :  %s" % (str(e) ) )
			invoice_id ="N/A"
			total_amount = "N/A"'''
		files = [filename]
		links_pdf =  ""
		
		
	sql = """select * from orig_invoice where client_id = %s order by invoice_id desc limit 1  """ % client['client_id']
	pg_cur.execute(sql)
	invoice_record = pg_cur.fetchone()
	if invoice_record != None:
		invoice_number = invoice_record['invoice_number']
		total_amount = invoice_record['total_amount']
		invoice_start = invoice_record['invoice_start']
		invoice_end  = invoice_record['invoice_end']
	else:
		invoice_number = "N/A"
		total_amount = "N/A"
		invoice_start = "N/A"
		invoice_end  = "N/A"
	print ("Files", str(files))
	#print ("links_pdf",links_pdf)
	# links_pdf + links_cdr
	#invoice_number = filename[0:filename.find('_') ] 
	mail_content = EmailTemplate.get('invoice_content',"N/A mail content in system cursor. Please report to administrator!") 
	
	print ("EMAIL CLIENT ROW:" , str(client.get('client_id','N/A')) ,  client.get('client_name','N/A') ,client.get('payment_term','N/A') )
	print ("mail_content",mail_content)
	mail_content = mail_content.replace('{company_name}',client.get('company','N/A')) .replace('{switch_alias}',str(smtp_info.get('switch_alias','N/A') )).replace('{start_date}',
	str(invoice_start)) .replace('{end_date}',str(invoice_end )) .replace('{invoice_number}',str(invoice_number )).replace('{invoice_link}',
	links_pdf).replace('{cdr_url}',"N.A.")  .replace('{client_name}',client.get('name','N/A'))   .replace('{invoice_amount}',str(total_amount))   
	
	mail_subject = mail_subject.replace('{company_name}',client.get('company','N/A')) .replace('{switch_alias}',str(smtp_info.get('switch_alias','N/A') )).replace('{start_date}',
	str(invoice_start)) .replace('{end_date}',str(invoice_end)) .replace('{invoice_number}',str(invoice_number )).replace('{invoice_link}',
	links_pdf).replace('{cdr_url}',"N.A.")  .replace('{client_name}',client.get('name','N/A')) . replace ( '{invoice_amount}'  ,str(total_amount)   ) 
	
	
	print ("mail_content ",mail_content)
	send_mail( send_from, invoice_cc ,send_to, mail_subject, mail_content, files, server, port, username, password, smtp_info,isTls)
	send_email_log( client,send_to,mail_subject, mail_content, 'http://%s/invoice/%s'  %  ( "", "N/A"),pg_cur )
	# make state = 9 in invoice 
	#sql = """update invoice set state = 9 where invoice_number = '%s'""" % invoice_number
	#print (sql)
	#pg_cur.execute(sql)
	
	

def invoice_history (filename, client,pg_cur,start_time,end_time):
	sql = ' select  notify_days as nd from payment_term where payment_term_id = %s'  % client['payment_term_id']
	print ("sql for getting notify_days: " + sql )
	pg_cur.execute(sql)
	result =pg_cur.fetchone() 
	print ("Result of notify_days  in invoice_history", result   )
	notify_days = result['nd']
	if notify_days == None:
		notify_days= 0
	#now = datetime.datetime.now()

	
	try:
		sql = ''' select sys_timezone from system_parameter offset 0 limit 1 ; '''
		pg_cur.execute(sql)
		time_zone = pg_cur.fetchone().get('sys_timezone','+00:00')
		time_zone = setTimeZone (time_zone)  #(client.get('invoice_zone', "+00:00"))
	except Exception as e:
		print("Do not get time zone for client auto invoice. setting to GMT %s" %e)
		logger.debug("Do not get time zone for client auto invoice. setting to GMT %s"%e)
		time_zone = 0
	now =   datetime.datetime.now() + datetime.timedelta(hours=time_zone) 
	notify_time = now+ datetime.timedelta(days=+notify_days)  #days
	epoch_secs_unblock = int (notify_time.timestamp())
	
	
	try:
		sql = "INSERT INTO invoice_history(client_id,reminders_count,next_reminder_timestamp,invoice_filename,start_time,end_time) values(%s,%s,%s,'%s','%s','%s')" % ( client['client_id'],notify_days ,epoch_secs_unblock ,filename ,start_time,end_time)
		logger.debug("Sql of updating client invoice history: %s"%sql)
		print("Sql of updating client invoice history: %s"%sql)
		pg_cur.execute(sql)
		sql = "UPDATE client SET last_invoiced = '%s'  WHERE client_id = %s" % (str(now), client['client_id'] )
		logger.debug("Sql of updating client invoice history: %s"%sql)
		print ("Sql of updating client invoice history: %s"%sql)
		pg_cur.execute(sql)
	except Exception as e: 
		print (" Exception in history invoice:  %s" % (str(e) ) )
		logger.error("Exception in history invoice: :  %s" % (str(e) ) )
	
	

def notify_carrier (pg_cur):
	now = datetime.datetime.now()
	epoch_secs_unblock = int (now.timestamp())
	sql = '''SELECT * FROM  invoice_history WHERE reminders_count > 0 AND next_reminder_timestamp < %s ''' % epoch_secs_unblock
	print ("query for getting reminders " + sql)
	pg_cur.execute(sql)
	result = pg_cur.fetchall()
	print ("result Notify: " , result,len(result))
	jobs = []
	fields = GetCdrFields(pg_cur)
	smtp_info = get_smtp_info(pg_cur)
	EmailTemplate = GetEmailTemplate(pg_cur)
	
	for reminder in result:
		#debug only
		if True:
			continue
		subject = '''Hello %s. This is reminder for your invoice'''
		sql = '''select * from client where client_id = %s ''' % reminder['client_id'] 
		print ("Query for getting Client details for notifing", sql)
		try:
			pg_cur.execute(sql)
			client= pg_cur.fetchone()
			sql = '''update  invoice_history set  reminders_count=reminders_count -1  WHERE  invoice_filename= '%s' '''% reminder['invoice_filename']
			pg_cur.execute(sql)
		except Exception as e: 
			print (" Exception in getting client for reminder:  %s" % (str(e) ) )
			logger.error("Exception in getting client for reminder :  %s" % (str(e) ) )
			continue
		data={'start_date':reminder['start_time'], 'end_date':reminder['end_time']}
		invoice_number = reminder['invoice_filename'] [:-16]
		#email_invoice (filename, client[0],pg_cur,data,fields ) 
		p = multiprocessing.Process(target=email_invoice, args=(reminder['invoice_filename'], client,pg_cur,data,fields,smtp_info,EmailTemplate,invoice_number,subject) )
		#p.daemon = True
		p.start()
		jobs.append(p)
		print (jobs)



def main(args):
	global config #pidfile
	config =   AUTOINVOICE_config                       #configparser.ConfigParser()
	#config.read('config.ini')
	
	global DEBUG_LEVEL , cdr_table ,FTP_HOST
	DEBUG_LEVEL = int (config["log"]["debug_level"] )
	#cdr_table = ""  #config["other"]["cdr_table"]
	# logger
	if int(config["log"].get('by_time',0) )== 1:
		handler = TimedRotatingFileHandler(config["log"].get ("invoice_auto_path","invoice_auto.log"),when=config["log"].get ("invoice_auto_when",'m'),
		interval= int( config["log"].get ("invoice_auto_interval",0) ),backupCount= int( config["log"].get ("invoice_auto_backupCount",5)  ) )
	else: # by size
		handler = RotatingFileHandler(config["log"].get ("invoice_auto_path","invoice_auto.log"),maxBytes=int( config["log"].get ("invoice_auto_maxBytes", 1024*1024*128 ) ),
		backupCount= int( config["log"].get ("invoice_auto_backupCount",5)  ) )
	
	if int (config["log"].get ("debug_level",0) ) == 1: 
		logger.setLevel(logging.DEBUG)
	else:
		logger.setLevel(logging.INFO)
	formatstr = '%(asctime)s - %(name)s - %(levelname)s - %(message)s'
	formatstr = '%(asctime)s: %(levelname)s:  %(message)s'
	formatter = logging.Formatter(formatstr)
	handler.setFormatter(formatter)
	logger.addHandler(handler)
	
	try:
		pg_conn, pg_cur = connect_to_postgresql(database["host"],int(database ["port"]), database ["database"], database ["user"],database ["password"]) #config ["password"]
		
		return pg_conn, pg_cur
	except Exception as e: 
		print (" Exception in connect_to_postgresql:  %s" % (str(e) ) )
		logger.error(" Exception in connect_to_postgresql:  %s" % (str(e) ) )
		return -1,-1

def performRequest(client,pg_cur):
	"""Performs get request to the DID Api"""
	#[client, invoice_start_date,invoice_end_date]
	start_time = datetime.datetime.strptime('000000','%H%M%S').time()
	end_time = datetime.datetime.strptime('235959','%H%M%S').time()
	_start_datetime = client[1]
	_end_datetime = client[2]
	start_datetime_epoch = int(datetime.datetime.combine(_start_datetime,start_time).timestamp())
	end_datetime_epoch = int(datetime.datetime.combine(_end_datetime,end_time).timestamp())
	client = client[0]
	
	try:
		path = config['other']['pdf_path']  +"/"+ str( client['client_name'] )  + ".pdf"
	except:
		path ="./"+ str( client['client_name'] )  + ".pdf"
	did_invoice_include  = client['did_invoice_include']
	if did_invoice_include == None:
		basic_url = "http://127.0.0.1:%s/invoice/client/%s/end/%s/start/%s/type/0/due/%s" % ( server_port, client['client_id'] ,end_datetime_epoch ,start_datetime_epoch,client['due'])
	else:
		basic_url = "http://127.0.0.1:%s/invoice/client/%s/end/%s/start/%s/type/0/due/%s/params/%s" % ( server_port, client['client_id'] ,end_datetime_epoch ,start_datetime_epoch,client['due'],did_invoice_include )
	print (basic_url)
	r = requests.get(basic_url, stream=True)
	if r.status_code == 200:
		with open(path, 'wb') as f:
			for chunk in r.iter_content(1024):
				f.write(chunk)
			return 0 , path
	else:
		print (r.status_code)
		print (r.text)
		return -1,r.text
	return -1 , "general error"


def fixedFees(pg_cur):
	from_date = datetime.datetime.today().strftime('%Y-%m-%d')
	query = sql_signatures.transaction_summary_analysis
	sql = sql_signatures.fees_for_balance  .format(invoice_date=from_date)
	pg_cur.execute(sql)
	print(sql)
	fees = pg_cur.fetchall()
	print(fees.copy())
	for fee in fees:
		_fee = float(fee['fee'])
		fee_total = float( fee['fee'])
		#print ("Fee ",   fee.copy())
		mode = fee['mode']
		if mode==2:  #postpaid
			client_id = fee['client_id']
			sql = sql_signatures.include_tax.format(client_id)
			#print(sql)
			pg_cur.execute(sql)
			taxes = pg_cur.fetchall()
			for tax in taxes:
				fee_total +=   (float(tax.get('tax_percent',0.0))/100) * _fee   #   fee + taxes*fee
		#print ( "For %s  . after taxes %s.  "  % ( fee.copy()  ,  fee_total   )    )
		sql = """INSERT INTO client_balance_operation_action  (client_id, balance,ingress_balance ,update_result,action ,create_by)   VALUES  
		 (%s,%s,%s,%s,'DID Invoice'  )  """  % (fee['client_id'],  fee_total,  fee_total, 0,3   )
		msg = "Query for decreasing client balance %s" %sql
		print (msg)
		logger.info(msg)
		pg_cur.execute(sql)
		
		
def season_fees(pg_cur):
	#check date and day of week
	today = datetime.date.today()
	day_of_month = today.day
	day_of_week = today.weekday()
	
	sql_balance = """INSERT INTO client_balance_operation_action  (client_id, balance,ingress_balance,update_result ,action ,create_by)   VALUES  
	({client_id},{fee},{fee},3,0,'DID Invoice'  )  """
	sql_update_one_time_setup = """ UPDATE  did_fees_history  SET  one_time_setup_fee_paid = true where client_id = {client_id}"""
	sql_update_port_fee = """ UPDATE  did_fees_history  SET  port_fee_last_payment = CURRENT_TIMESTAMP::date where client_id = {client_id}"""
	sql_update_season_fee =  """ UPDATE  did_fees_history  SET  did_fixed_fees_last_payment = CURRENT_TIMESTAMP::date where client_id = {client_id}"""
	
	
	if day_of_week ==0 :  #0
		sql = sql_signatures.season_port_fee_balance .format(invoice_date=today)
		logger.debug("Today is Monday")
		msg = "Query for getting season fees/port fees and one type setup fee %s" % sql
		logger.debug(msg)
		print (sql)
		pg_cur.execute(sql)
		season_fees = pg_cur.fetchall()
		if season_fees == None:
			return
		for fee in season_fees:
			msg = "Fee %s"% str(fee.copy())
			logger.debug(msg)
			print(fee.copy())
			description = fee['description']
			#check for exisiting client_id in did_fees_history
			sql = """select count(*) as count from did_fees_history where client_id = {client_id}"""
			sql =  sql.format( client_id = fee['client_id']  )
			pg_cur.execute(sql)
			count = pg_cur.fetchone()['count']
			if count ==0:
				sql = "INSERT INTO did_fees_history (client_id) VALUES ({client_id})"
				sql =  sql.format( client_id = fee['client_id']  )
				pg_cur.execute(sql)
			
			if fee['pay_type'] == 0: #weekly
				postpay  =    fee['mode']  == 2
				tax_percent =1 
				if postpay :
					#getting tax percentige
					sql = sql_signatures.include_tax.format(fee['client_id'])
					print (sql)
					pg_cur.execute(sql)
					taxes = pg_cur.fetchall()
					if taxes != None:
						for tax in taxes:
							tax_percent *= (tax_percent/100 +1)
					
				print("tax_percent",tax_percent)
				if description.find("One-time Setup Fee" ) != -1:
					#setup fee
					print ("SETUP FEE!")
					if fee['one_time_setup_fee_paid'] == None or fee['one_time_setup_fee_paid'] == False:
						sql =  sql_balance.format( client_id = fee['client_id'] ,fee = fee['fee'] )
						msg = "Query for decreasing client balance %s" %sql
						print (msg)
						logger.info(msg)
						pg_cur.execute(sql)
						sql = sql_update_one_time_setup.format ( client_id = fee['client_id']  )
						msg = "Query for updating client fee history %s" %sql
						print (msg)
						logger.info(msg)
						pg_cur.execute(sql)
				elif description.find("Port Fee" ) != -1:
					if True: continue
					#port fee once in a month
					if fee['port_fee_last_payment'] == None :
						sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent )
						msg = "Query for decreasing client balance %s" %sql
						print (msg)
						logger.info(msg)
						pg_cur.execute(sql)
						sql = sql_update_port_fee .format ( client_id = fee['client_id']  )
						msg = "Query for updating client fee history %s" %sql
						print (msg)
						logger.info(msg)
						pg_cur.execute(sql)
					else:
						last_payment_date = fee['port_fee_last_payment']
						today = datetime.date.today()
						if last_payment_date.month  <  today.month: #old port payment 
							sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent )
							msg = "Query for decreasing client balance %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
							sql = sql_update_port_fee .format ( client_id = fee['client_id']  )
							msg = "Query for updating client fee history %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
				else: #Season Fee for DID last_paid_fees
					if True: continue
					#Season fee once in a week
					if fee['last_paid_fees'] == None :
						sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent )
						msg = "Query for decreasing client balance %s" %sql
						print (msg)
						logger.info(msg)
						pg_cur.execute(sql)
						sql = sql_update_season_fee .format ( client_id = fee['client_id']  )
						msg = "Query for updating client fee history %s" %sql
						print (msg)
						logger.info(msg)
						pg_cur.execute(sql)
					else:
						last_payment_date = fee['last_paid_fees']
						today = datetime.date.today()
						if last_payment_date  <  today  -  datetime.timedelta(hours=48): #old port payment 
							sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent)
							msg = "Query for decreasing client balance %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
							sql = sql_update_season_fee .format ( client_id = fee['client_id']  )
							msg = "Query for updating client fee history %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
	
	if day_of_month == 1:
		if True: return
		sql = sql_signatures.season_port_fee_balance_month.format(invoice_date=today)
		logger.debug("Today is 1sth day of the month")
		msg = "Query for getting season fees/port fees and one type setup fee %s" % sql
		logger.debug(msg)
		#print (sql)
		pg_cur.execute(sql)
		season_fees = pg_cur.fetchall()
		if season_fees == None:
			return
		for fee in season_fees:
			msg = "Fee %s"% str(fee.copy())
			logger.debug(msg)
			print(fee.copy())
			
			if fee['pay_type'] == 1: #monthly
				postpay  =    fee['mode']  == 2
				tax_percent =1 
				if postpay :
					#getting tax percentige
					sql = sql_signatures.include_tax.format(fee['client_id'])
					print (sql)
					pg_cur.execute(sql)
					taxes = pg_cur.fetchall()
					if taxes != None:
						for tax in taxes:
							tax_percent *= (tax_percent/100 +1)
					
				print("tax_percent",tax_percent)
			
				description = fee['description']
				#check for exisiting client_id in did_fees_history
				sql = """select count(*) as count from did_fees_history where client_id = {client_id}"""
				sql =  sql.format( client_id = fee['client_id']  )
				pg_cur.execute(sql)
				count = pg_cur.fetchone()['count']
				if count ==0:
					sql = "INSERT INTO did_fees_history (client_id) VALUES ({client_id})"
					sql =  sql.format( client_id = fee['client_id']  )
					pg_cur.execute(sql)
				
					if description.find("One-time Setup Fee" ) != -1:
						#setup fee
						if fee['one_time_setup_fee_paid'] == None or fee['one_time_setup_fee_paid'] == False:
							sql =  sql_balance.format( client_id = fee['client_id'] ,fee = fee['fee'] )
							msg = "Query for decreasing client balance %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
							sql = sql_update_one_time_setup.format ( client_id = fee['client_id']  )
							msg = "Query for updating client fee history %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
					elif description.find("Port Fee" ) != -1:
						#port fee once in a month
						if fee['port_fee_last_payment'] == None :
							sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent )
							msg = "Query for decreasing client balance %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
							sql = sql_update_port_fee .format ( client_id = fee['client_id']  )
							msg = "Query for updating client fee history %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
						else:
							last_payment_date = fee['port_fee_last_payment']
							today = datetime.date.today()
							if last_payment_date.month  <  today.month: #old port payment 
								sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent )
								msg = "Query for decreasing client balance %s" %sql
								print (msg)
								logger.info(msg)
								pg_cur.execute(sql)
								sql = sql_update_port_fee .format ( client_id = fee['client_id']  )
								msg = "Query for updating client fee history %s" %sql
								print (msg)
								logger.info(msg)
								pg_cur.execute(sql)
					else: #Season Fee for DID last_paid_fees
						#Season fee once in a week
						if fee['last_paid_fees'] == None :
							sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent)
							msg = "Query for decreasing client balance %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
							sql = sql_update_season_fee .format ( client_id = fee['client_id']  )
							msg = "Query for updating client fee history %s" %sql
							print (msg)
							logger.info(msg)
							pg_cur.execute(sql)
						else:
							last_payment_date = fee['last_paid_fees']
							today = datetime.date.today()
							if last_payment_date.month  <  today.month: #old port payment 
								sql =  sql_balance.format( client_id = fee['client_id'] ,fee = float(fee['fee'])*tax_percent)
								msg = "Query for decreasing client balance %s" %sql
								print (msg)
								logger.info(msg)
								pg_cur.execute(sql)
								sql = sql_update_season_fee .format ( client_id = fee['client_id']  )
								msg = "Query for updating client fee history %s" %sql
								print (msg)
								logger.info(msg)
								pg_cur.execute(sql)
		

def main_start(pg_conn, pg_cur):
	# add to log table
	sql ="INSERT INTO scheduler_log (script_name, start_time) VALUES ('Did Invoice Auto', current_timestamp(0))";
	pg_cur.execute(sql)
	logger.info(sql)
	#notify_carrier(pg_cur)
	
	try:
		season_fees(pg_cur)
	except Exception as e:
		traceback.print_exc(file=sys.stdout)
		msg = "Error in fixedFees %s" %e
		logger.error(msg)
	
	return 20
	invoice_log_start_time = datetime.date.today().strftime(( "%Y-%m-%d %H:%M:%S"))

	pg_cur.execute(PAYMENT_TERM_SQL)
	result =pg_cur.fetchall()
	payment_dict = dict()
	for row in result:
		payment_dict[row['payment_term_id']] =  dict(row)
	
	client_list = []
	pg_cur.execute(INVOICE_SQL)
	result =pg_cur.fetchall()
	for row in result:
		new_client_dict = dict(row)
		try:
			new_client_dict[ 'days' ] = payment_dict [new_client_dict ['payment_term_id']] ['days'] 
			new_client_dict[ 'type' ] = payment_dict [new_client_dict ['payment_term_id'] ] ['type'] 
			new_client_dict[ 'due' ] = payment_dict [new_client_dict ['payment_term_id'] ] ['grace_days']
			new_client_dict[ 'more_days' ] = payment_dict [new_client_dict ['payment_term_id'] ] ['more_days']
			
		except Exception as e:
			print ("Error in getting payment row",e)
			continue
		client_list.append(new_client_dict)
	#debug:
	for row in client_list:
		print("Clients for autoinvoice:", row.get("client_id","N/A"),row.get("name","N/A"))
	#print ("client_dict:" ,client_dict ) 
	total_invoices = 0
	try:
		total_invoices, invoices_needed = checkClients(result,client_list,total_invoices,pg_cur)
	except Exception as e:
		print ("Error in checkClients %s"%e) 
		logger.error("Error in checkClients %s"%e) 
		traceback.print_exc(file=sys.stdout)
	print ("total inv:", total_invoices)
	##only for debug!!
	#fields = GetCdrFields(pg_cur)
	EmailTemplate = GetEmailTemplate (pg_cur)
	smtp_info = get_smtp_info(pg_cur)
	jobs = []
	fields = ""
	print ("Invoices neede on that loop %s"%len(invoices_needed))
	for client in invoices_needed:  # client[0] - client , start_date, end_date, invoice_due_date
		print ("Client for invoicing",client[0]['client_name'],client[0]['client_id'])
		try:
			status,filepath = performRequest(client,pg_cur) 
			#continue
		except Exception as e:
			print ("Error in performRequest %s"%e) 
			logger.error("Error in performRequest %s"%e) 
			continue
		# check for invoice_zero & bill = 0
		print (status,filepath)
		if status == -1:
			print ("Error in request")
			logger.error ("Error in request")
			continue

		if client[0].get('email_invoice',False) == True:
			try:
				email_invoice(filepath, client[0],pg_cur,smtp_info,EmailTemplate )
				invoice_history (filepath, client[0],pg_cur,client[1],client[2])
				
			except Exception as e:
				print ("Error in email_invoice %s"%e) 
				logger.error("Error in email_invoice %s"%e) 
				continue
				
		else:
			print ( "Client %s  Do not want email" % client[0].get('client_id') )
		#logger.error ('Error in logging script execution in table invoice_log %s'% str(e))

	
	return 0
    
def worker(event):
	killer = GracefulKiller()



	while True:

		try:
			pg_conn,pg_cur = main (sys.argv)
			if pg_cur == -1:
				exit (1)
			main_start(pg_conn,pg_cur)
		except Exception as e:
			logger.error("Error in Main Auto start loop  %s" % str(e))
			print("Error in Main Auto start loop7 %s "% str(e))
			try:
				time.sleep(60)  # sleep for a minute before continue
				pg_conn,pg_cur = main (sys.argv)
				continue
			except Exception as e:
				logger.error("SECOND Error in Main Auto start loop  %s" % str(e))
				print("SECOND Error in Main Auto start loop7 %s "% str(e))
				#pg_conn.close()
				#pg_cur.close()
				exit(1)
		for dummy in range(60*6):
			if event.is_set():
				logger.info("TERM SIG! EXITING NOW ")
				print("Auto Process: TERM SIG! EXITING NOW ")
				exit(0)
			
			time.sleep(10)
    

if __name__ == '__main__':
	
	if os.geteuid() == 0:
		exit("You do not need to have root privileges to run this script.\nPlease try again, this time without using sudo. Exiting.")
	logger_dmon = logging.getLogger('DID Auto invoice Dmon')
	handler = RotatingFileHandler("logs/invoice_dmon.log",maxBytes=1024*1024*128 ,backupCount= 10 )
	logger_dmon.setLevel(logging.DEBUG)
	
	formatstr = '%(asctime)s - %(name)s - %(levelname)s - %(message)s'
	formatstr = '%(asctime)s: %(levelname)s:  %(message)s'
	formatter = logging.Formatter(formatstr)
	handler.setFormatter(formatter)
	logger_dmon.addHandler(handler)
	
	
	parser = argparse.ArgumentParser(description='Invoice DID API')
	#parser.add_argument('-a', '--action',   help='Action to be taken. start , stop')  #default='start'
	parser.add_argument('-H', '--host', default='0.0.0.0' ,  help='host for Invoice DID API')
	parser.add_argument('-P', '--port', default= 18881 ,  help='port for Invoice  DID API')
	args = parser.parse_args()
	host = args.host
	port = args.port
	#server_port  = port
	logger_dmon.debug("Starting Did Server "  ) #%( host,port )
	#proc =     startDid(port,host)
	#pid = proc.pid 
	proc =  "excluded"
	'''try:
		outs, errs = proc.communicate(timeout=10)
	#status = "Cout: %s and Cerr: %s   "
	
		info = "Server is running on pid %s. Status of cout: %s and of cerr %s " %  (pid,outs,errs   )
		logger_dmon.debug(info)
		print(info)
	except:
		pass
	'''
	killer = GracefulKiller(proc,logger_dmon)
	
	while True:
		pg_conn,pg_cur = main (sys.argv)
		if pg_cur == -1:
			info =  " Autoinvoice module start failer. Please check DB settings! "
			logger_dmon.debug(info)
			exit (1)
		main_start(pg_conn,pg_cur)
		for dummy in range(60*3):
			time.sleep(3) 
		pg_cur.close()
		pg_conn.close()
		
     
     #sys.exit(main(sys.argv))
