from datetime import datetime

import psycopg2
import urllib.request

from get_config import database, invoices_path

def main():
    conn = psycopg2.connect(
        'host={} port={} user={} dbname={} password={}'.format(
                database['host'], database['port'], database['user'], 
                database['database'], database['password']))
    cur = conn.cursor()
    cur.execute('SELECT client_id FROM client WHERE is_orig_term')
    recs = cur.fetchall()
    for rec in recs:
        end = int(datetime.now().timestamp())
        file_name = '{}/{}_{}.pdf'.format(invoices_path, rec[0], end)
        url = 'http://127.0.0.1:8881/invoice/client/{}/end/{}'.format(rec[0], end)
        with urllib.request.urlopen(url) as response, open(file_name, 'wb') as out_file:
            data = response.read()
            out_file.write(data)


if __name__ == "__main__":
    main()
