import os, glob, shutil
import fileinput
import re
from datetime import datetime
import pexpect,sys
upd_rel = 0
git_dir =  os.path.expanduser("~/git")
spec_dir =  os.path.expanduser("~/denovolab/rpmbuild/SPECS/")
rpm_dir = os.path.expanduser("~/rpmbuild/SOURCES")
os.chdir(git_dir)
spec_files = []

def repl_ver(matchobj):
  global upd_rel
  datever = datetime.now().date().strftime('%Y%m%d')
  if datever == matchobj.group(2):
    upd_rel = 1
  return matchobj.group(1)+datever

def repl_rel(matchobj):
  global upd_rel
  if upd_rel == 1:
    return str(int(matchobj.group(1))+1)
  else:
    return '1'

def repl_relv5(matchobj):
  return str(int(matchobj.group(1))+1)


##
def git_pull_make(version):

  assert(version in [3, 5])

  from subprocess import Popen, PIPE

  # helper function
  def perform_pull(cwd):
    git_command = ['/usr/bin/git', 'pull']

    git_query = Popen(git_command, cwd=cwd, stdout=PIPE, stderr=PIPE)
    (git_status, error) = git_query.communicate()
    if git_query.poll() == 0:
      if re.search('Already up-to-date', git_status.decode('utf-8')) is None:
        # there were some changes
        return True

    return False

  updates_count = 0

  for fname in os.listdir(git_dir):
    path = os.path.join(git_dir, fname)
    if os.path.isdir(path) and fname.startswith("softswitch4v" + str(version)) and os.path.isdir(os.path.join(path, ".git")):
      print("fname found ", fname, " for version ", version)
      os.chdir(path)
      if perform_pull(path):
        updates_count += 1
      os.chdir(git_dir)

  if updates_count > 0:
    print("updates found for version ", str(version))
    for f in glob.glob("softswitch4" + str(version) + "*.tar.gz"):
      os.remove(f)
    os.system("make")

  return updates_count > 0
##

#old version
#def git_pull_make():
#  for dir in os.listdir(git_dir):
#    if os.path.isdir(dir):
#      os.chdir(dir)
#      os.system("git pull")
#      os.chdir(git_dir)
#  for f in glob.glob("softswitch*.tar.gz"):
#    os.remove(f)
#  os.system("make")

def edit_spec(version):
 os.chdir(git_dir)
 for f in glob.glob("softswitch4v" + str(version) + "*.tar.gz"):
   shutil.copyfile(git_dir+'/'+f, rpm_dir+'/'+f)
   spec_name, ver  = f.replace('.tar.gz','').split('-')
   print(spec_name, ver)
   spec_file = spec_dir + spec_name + '.spec'
   spec_files.append(spec_file)

   for line in fileinput.input(spec_file, inplace = 1):
     if re.search('global ver',line):
       line = re.sub('global ver .*', 'global ver %s' % ver, line)
     if re.search('Version:\s+',line):
       line = re.sub('(\d+\.\d+\.)(\d+)', repl_ver, line)
     if re.search('Release:',line):
       line = re.sub('(\d+)', repl_rel, line)
     print(line, end='')

   dbspec_file = spec_dir+'postgresql96-'+spec_name+'-config.spec'
   spec_files.append(dbspec_file)
   print(upd_rel)
   for line in fileinput.input(dbspec_file, inplace = 1):
     if re.search('global ver',line):
       line = re.sub('global ver .*', 'global ver %s' % ver, line)
     if re.search('Version:\s+',line):
       line = re.sub('(\d+\.\d+\.)(\d+)', repl_ver, line)
     if re.search('Release:',line):
       if '4v5' in spec_name:
         line = re.sub('(\d+)', repl_relv5, line)
       else:
         line = re.sub('(\d+)', repl_rel, line)

     if re.search('Source:',line) and '4v5' in spec_name:
       line = re.sub('-.*\.tar\.gz', '-%s.tar.gz' % ver, line)
     print(line, end='')

def rpmbuild():
  os.chdir(git_dir)
  for spec_file in spec_files:
    os.system('rpmbuild -bb %s' % spec_file)
  p = pexpect.spawnu('/bin/bash -c "find /home/rpmbuild/rpmbuild/RPMS/ -name *.rpm | xargs rpmsign --addsign"')
  p.logfile = sys.stdout
  #p = pexpect.spawn('find  -name *.rpm')
  index = p.expect(['Enter pass phrase:',  pexpect.EOF, pexpect.TIMEOUT])
  #index = p.pexpect(['Enter pass phrase:',  pexpect.EOF, pexpect.TIMEOUT])
  if index == 0:
    print ( "rpmsign wants the password" )
    #num = p.sendline("dnlDNL")
    num = p.send("dnlDNL")
    print (num)
  elif index == 1:
    print ( "EOF" )
  elif index == 2:
    print ( "rpmsign finished" )
  #os.system('find /home/rpmbuild/rpmbuild/RPMS/ -name *.rpm | xargs rpmsign --addsign')
  os.system('rsync -vr --delete /home/rpmbuild/rpmbuild/RPMS/ /opt/repository/dnl/7/ && createrepo /opt/repository/dnl/7')
  #os.system('update-repo')


"""
main code
"""
for version in [3, 5]:
  #if git_pull_make(version):
    print("updates found for version ", str(version))
    spec_files = []
    edit_spec(version)
#    os.system("make scripts")
#    shutil.copyfile(git_dir+'/softswitch-supportscripts.tar.gz', rpm_dir+'/softswitch-supportscripts.tar.gz')
    rpmbuild()
