# Previous Balance
# This is the ending balance of the last day of previous month after 
# the last month’s invoice was sent.
# The table is balance_history_actual (deprecated)
# Table is c4_client_balance
get_balance = '''
    SELECT c4_client_balance.balance AS actual_balance 
    FROM c4_client_balance
    WHERE c4_client_balance.client_id::int = {}
        AND c4_client_balance.create_time::date < date_trunc('month', '{}'::date)
    LIMIT 1;
    '''

# invoice requisites
inv_requisites = '''
    SELECT tpl_number, pdf_tpl, company_info, company_info_location, invoice_decimal_digits
    FROM system_parameter
    LIMIT 1;
    '''


client_invoice_zero = """ select invoice_zero from client where client_id = {client_id}"""


client_last_invoiced = """ select last_invoiced from client where client_id = {client_id}"""

#get_invoice_path
get_invoice_path = '''
select pdf_path,invoice_number from orig_invoice where invoice_id = {invoice_id}
     '''

# create invoice
create_invoice = '''
    INSERT INTO orig_invoice (invoice_number, state, client_id, invoice_time, 
        invoice_start, invoice_end, total_amount, pdf_path,create_type)
    VALUES ({invoice_number}, {state}, {client_id}, CURRENT_TIMESTAMP, 
        to_timestamp({invoice_start}), to_timestamp({invoice_end}), {total_amount}, '{pdf_path}',{create_type}) returning invoice_id;
    '''
    # '''
    # INSERT INTO invoice (invoice_number, client_id, invoice_time, invoice_start,
    #     invoice_end, total_amount, current_balance)
    # VALUES ({invoice_number}, {client_id}, CURRENT_TIMESTAMP, to_timestamp({invoice_start}),
    #     to_timestamp({invoice_end}), {total_amount}, {current_balance});
    # '''
#update_last_invoiced
update_last_invoiced = ''' UPDATE client SET last_invoiced = CURRENT_TIMESTAMP  WHERE client_id = {client_id} '''

# invoice number
last_invoice_number = '''
    SELECT nextval('class4_seq_invoice_no') AS last_invoice_number;
    '''

# check invoice number
check_invoice_number = '''
    SELECT invoice_id FROM invoice WHERE invoice_number = {}::text;
    '''

# last_invoice_number = '''
#     SELECT nextval('class4_seq_invoice_no')  AS last_invoice_number;
#     SELECT greatest(
#         coalesce((
#             SELECT
#                 CASE
#                     WHEN trim(invoice_name) ~ E'^\\\\d+$' THEN trim(invoice_name)::integer
#                     ELSE 0
#                 END AS convention
#             FROM system_parameter
#             LIMIT 1), 0),
#         coalesce((
#             SELECT MAX(invoice_number::integer) as last_invoice_number
#             FROM invoice
#             WHERE invoice_number ~ E'^\\\\d+$'), 0)
#     ) AS last_invoice_number;
#     '''

# company_name
company_name = '''SELECT company AS company_name FROM client WHERE client.client_id = {};'''


# some client info
include_tax = '''SELECT  tax_name, tax_percent  FROM client left join client_taxes on
  client.client_id = client_taxes.client_id  WHERE client.client_id = {} and include_tax is true and tax_percent is not null;  '''


decimal_place = '''SELECT  decimal_place  FROM client  WHERE client.client_id = {} ;  '''



# egress_ids for client_id
egress_ids = '''
    SELECT array_to_string(array_agg(resource.resource_id), ',') as egress_ids,
        resource.client_id
    FROM resource
    WHERE resource.client_id = {}
        AND resource.egress
    GROUP BY resource.client_id
    ORDER BY resource.client_id;
    '''

# Transaction Summary Analysis
transaction_summary_analysis_old = '''
    SELECT t.description, t.fee
    FROM (
        SELECT 'One-time Setup Fee for DID ' || did_billing_rel.did AS description,
            CASE 
                WHEN date_trunc('month', coalesce(did_billing_rel.start_date, CURRENT_DATE)) = 
                    date_trunc('month', '{invoice_date}'::date) THEN coalesce(did_billing_plan.did_price, 0.0)
                ELSE 0.0
            END AS fee
        FROM resource
            INNER JOIN did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.sell_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND resource.client_id = {client_id}
        UNION ALL
        SELECT 'Monthly Fee for DID ' || did_billing_rel.did AS description, 
            did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) AS fee
        FROM resource
            INNER JOIN (
                SELECT t.did, t.ingress_res_id, t.sell_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days
                FROM (
                    SELECT did_billing_rel.did, did_billing_rel.ingress_res_id, did_billing_rel.sell_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.sell_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND resource.client_id = {client_id}
            AND did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) > 0
    ) AS t
    WHERE t.fee > 0
    '''


fees_for_balance = """select  t.client_id , t.description,
   CASE 
     WHEN date_trunc('month', coalesce(did_fees_history.did_fixed_fees_last_payment, CURRENT_DATE - INTERVAL '1 months')) < 
        date_trunc('month', '{invoice_date}'::date) THEN t.fee
     else 0.0
   END AS fee  ,
   date_trunc('month', coalesce(did_fees_history.did_fixed_fees_last_payment, CURRENT_DATE - INTERVAL '1 months')) as last_paid_fees 
   ,client.mode FROM client
    INNER JOIN
     (    SELECT t.client_id,t.description, t.fee
    FROM (
        SELECT    resource.client_id ,'One-time Setup Fee for DID ' || did_billing_rel.did AS description,
            CASE 
                WHEN date_trunc('month', coalesce(did_billing_rel.start_date, CURRENT_DATE)) = 
                    date_trunc('month', '{invoice_date}'::date) THEN coalesce(did_billing_plan.did_price, 0.0)
                ELSE 0.0
            END AS fee
        FROM resource
            INNER JOIN did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
        UNION ALL
        SELECT resource.client_id, 'Monthly Fee for DID ' || did_billing_rel.did AS description, 
            did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) AS fee
        FROM resource
            INNER JOIN (
                SELECT t.did, t.ingress_res_id, t.sell_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days
                FROM (
                    SELECT did_billing_rel.did, did_billing_rel.ingress_res_id, did_billing_rel.sell_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.sell_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) > 0
    ) AS t
    WHERE t.fee > 0
    UNION ALL  
    
   SELECT resource.client_id , 'Port Fee for DID ' || did_billing_rel.did AS description,  resource.dnis_cap_limit* did_billing_plan.fee_per_port as fee 
        FROM resource
            INNER JOIN (
                SELECT t.did,  t.buy_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days, t.egress_res_id,
                t.ingress_res_id
                 FROM (
                    SELECT did_billing_rel.did,  did_billing_rel.ingress_res_id,did_billing_rel.egress_res_id,did_billing_rel.buy_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND did_billing_rel.days / did_billing_rel.days_in_month * (  coalesce(did_billing_plan.fee_per_port, 0.0)* coalesce(resource.dnis_cap_limit, 0.0) ) > 0      
    
     ) as t  on client.client_id = t.client_id 
    LEFT JOIN
         did_fees_history on did_fees_history.client_id = t.client_id  ;"""



season_port_fee_balance = """ select  t.client_id , t.description,t.fee as fee  ,
   did_fees_history.did_fixed_fees_last_payment::date as last_paid_fees  
   ,did_fees_history.port_fee_last_payment::date  as port_fee_last_payment , did_fees_history.one_time_setup_fee_paid as one_time_setup_fee_paid
   ,client.mode ,  t.pay_type  FROM client
    INNER JOIN
     (    SELECT t.client_id,t.description, t.fee ,t.pay_type
    FROM (
        SELECT    resource.client_id ,'One-time Setup Fee for DID ' || did_billing_rel.did AS description,
            CASE 
                WHEN date_trunc('month', coalesce(did_billing_rel.start_date, CURRENT_DATE)) = 
                    date_trunc('month', '{invoice_date}'::date) THEN coalesce(did_billing_plan.did_price, 0.0)
                ELSE 0.0
            END AS fee , did_billing_plan.pay_type as pay_type
        FROM resource
            INNER JOIN did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
        
        UNION ALL
        
        SELECT resource.client_id, 'Season Fee for DID ' || did_billing_rel.did AS description, 
            did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) AS fee , did_billing_plan.pay_type as pay_type
        FROM resource
            INNER JOIN (
                SELECT t.did, t.ingress_res_id, t.sell_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days, t.start_date,t.end_date
                FROM (
                    SELECT did_billing_rel.did, did_billing_rel.ingress_res_id, did_billing_rel.sell_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, '{invoice_date}'::date  - '7 DAY'::interval  -'1 SECOND'::interval  )::date AS start_date,
                        LEAST(did_billing_rel.end_date, '{invoice_date}'::date -'1 SECOND'::interval   )::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.sell_billing_plan_id = did_billing_plan.id
        WHERE resource.egress  AND did_billing_plan.pay_type = 0 
            AND did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) > 0
    ) AS t
    WHERE t.fee > 0
    
    UNION ALL  
    
   SELECT resource.client_id , 'Port Fee for DID ' || did_billing_rel.did AS description,  resource.dnis_cap_limit* did_billing_plan.fee_per_port as fee , did_billing_plan.pay_type as pay_type
        FROM resource
            INNER JOIN (
                SELECT t.did,  t.buy_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days, t.egress_res_id,
                t.ingress_res_id
                 FROM (
                    SELECT did_billing_rel.did,  did_billing_rel.ingress_res_id,did_billing_rel.egress_res_id,did_billing_rel.buy_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND did_billing_rel.days / did_billing_rel.days_in_month * (  coalesce(did_billing_plan.fee_per_port, 0.0)* coalesce(resource.dnis_cap_limit, 0.0) ) > 0      
    
     ) as t  on client.client_id = t.client_id 
    LEFT JOIN
         did_fees_history on did_fees_history.client_id = t.client_id """

season_port_fee_balance_month = """ select  t.client_id , t.description,t.fee as fee  ,
   did_fees_history.did_fixed_fees_last_payment::date as last_paid_fees  
   ,did_fees_history.port_fee_last_payment::date  as port_fee_last_payment , did_fees_history.one_time_setup_fee_paid as one_time_setup_fee_paid
   ,client.mode ,  t.pay_type  FROM client
    INNER JOIN
     (    SELECT t.client_id,t.description, t.fee ,t.pay_type
    FROM (
        SELECT    resource.client_id ,'One-time Setup Fee for DID ' || did_billing_rel.did AS description,
            CASE 
                WHEN date_trunc('month', coalesce(did_billing_rel.start_date, CURRENT_DATE)) = 
                    date_trunc('month', '{invoice_date}'::date) THEN coalesce(did_billing_plan.did_price, 0.0)
                ELSE 0.0
            END AS fee , did_billing_plan.pay_type as pay_type
        FROM resource
            INNER JOIN did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
        
        UNION ALL
        
        SELECT resource.client_id, 'Season Fee for DID ' || did_billing_rel.did AS description, 
            did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) AS fee , did_billing_plan.pay_type as pay_type
        FROM resource
            INNER JOIN (
                SELECT t.did, t.ingress_res_id, t.sell_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days, t.start_date,t.end_date
                FROM (
                    SELECT did_billing_rel.did, did_billing_rel.ingress_res_id, did_billing_rel.sell_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.sell_billing_plan_id = did_billing_plan.id
        WHERE resource.egress  AND did_billing_plan.pay_type = 0 
            AND did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) > 0
    ) AS t
    WHERE t.fee > 0
    
    UNION ALL  
    
   SELECT resource.client_id , 'Port Fee for DID ' || did_billing_rel.did AS description,  resource.dnis_cap_limit* did_billing_plan.fee_per_port as fee , did_billing_plan.pay_type as pay_type
        FROM resource
            INNER JOIN (
                SELECT t.did,  t.buy_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days,  t.egress_res_id,
                t.ingress_res_id
                 FROM (
                    SELECT did_billing_rel.did,  did_billing_rel.ingress_res_id,did_billing_rel.egress_res_id,did_billing_rel.buy_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND did_billing_rel.days / did_billing_rel.days_in_month * (  coalesce(did_billing_plan.fee_per_port, 0.0)* coalesce(resource.dnis_cap_limit, 0.0) ) > 0      
    
     ) as t  on client.client_id = t.client_id 
    LEFT JOIN
         did_fees_history on did_fees_history.client_id = t.client_id """




#It should be buy_billing_idИзпратено на:17:07От:Sourav For others also, like fixed rate and did_price, it is buy_billing_id


port_fee_summary_analysis = '''
 SELECT did_billing_rel.did AS description, 
            coalesce(did_billing_plan.fee_per_port ) AS fee_per_port, resource.dnis_cap_limit , resource.dnis_cap_limit* did_billing_plan.fee_per_port as port_fee_total
        FROM resource
            INNER JOIN (
                SELECT t.did,  t.buy_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days,  t.egress_res_id,
                t.ingress_res_id
                 FROM (
                    SELECT did_billing_rel.did,  did_billing_rel.ingress_res_id,did_billing_rel.egress_res_id,did_billing_rel.buy_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND resource.client_id = {client_id}
            AND did_billing_rel.days / did_billing_rel.days_in_month * (  coalesce(did_billing_plan.fee_per_port, 0.0)* coalesce(resource.dnis_cap_limit, 0.0) ) > 0  ; '''



# Transaction Summary Analysis
transaction_summary_analysis = '''
    SELECT t.description, t.fee
    FROM (
        SELECT 'One-time Setup Fee for DID ' || did_billing_rel.did AS description,
            CASE 
                WHEN date_trunc('month', coalesce(did_billing_rel.start_date, CURRENT_DATE)) = 
                    date_trunc('month', '{invoice_date}'::date) THEN coalesce(did_billing_plan.did_price, 0.0)
                ELSE 0.0
            END AS fee
        FROM resource
            INNER JOIN did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.sell_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND resource.client_id = {client_id}
        UNION ALL
        SELECT 'Monthly Fee for DID ' || did_billing_rel.did AS description, 
            coalesce(did_billing_plan.monthly_charge, 0.0) AS fee
        FROM resource
            INNER JOIN (
                SELECT t.did, t.ingress_res_id, t.buy_billing_plan_id, t.days_in_month, t.end_date - t.start_date + 1 AS days
                FROM (
                    SELECT did_billing_rel.did, did_billing_rel.ingress_res_id, did_billing_rel.buy_billing_plan_id,
                        date_part('days', date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval) AS days_in_month,
                        GREATEST(did_billing_rel.start_date, date_trunc('month', '{invoice_date}'::date)::date) AS start_date,
                        LEAST(did_billing_rel.end_date, date_trunc('month', '{invoice_date}'::date) + '1 MONTH'::interval - '1 DAY'::interval)::date AS end_date
                    FROM did_billing_rel
                ) t
                WHERE t.end_date - t.start_date > -1) did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND resource.client_id = {client_id}
            AND did_billing_rel.days / did_billing_rel.days_in_month * coalesce(did_billing_plan.monthly_charge, 0.0) > 0
    ) AS t
    WHERE  t.fee > 0 '''


get_did_billing_id = '''
            
   SELECT did_billing_plan.id
        FROM resource
            INNER JOIN did_billing_rel ON did_billing_rel.ingress_res_id = resource.resource_id
            INNER JOIN did_billing_plan ON did_billing_rel.buy_billing_plan_id = did_billing_plan.id
        WHERE resource.egress 
            AND resource.client_id = {client_id}
    '''

zero_did_billing_did_price = '''UPDATE did_billing_plan SET did_price = 0 WHERE id = {did_billing_id}'''



# Toll Free = Number begins with 800, 888, 877,866,855,844
toll_free_digits = '''
    SELECT DISTINCT product_items.digits
    FROM resource
        INNER JOIN product_items_resource ON resource.resource_id = product_items_resource.resource_id
        INNER JOIN product_items ON product_items_resource.item_id = product_items.item_id
    WHERE resource.client_id = {}
        AND resource.egress
        AND left(product_items.digits::text, 3) IN ('800', '888', '877', '866', '855', '844');
    '''

# US Local = if the first 6 digits meets with the code field in the US Jurisdiction table
US_local_digits = '''
    SELECT DISTINCT product_items.digits
    from resource
        INNER JOIN product_items_resource ON resource.resource_id = product_items_resource.resource_id
        INNER JOIN product_items ON product_items_resource.item_id = product_items.item_id
        INNER JOIN jurisdiction_prefix ON left(product_items.digits::text, 6) = jurisdiction_prefix.prefix::text 
                        OR ('1' || left(product_items.digits::text, 6)) = jurisdiction_prefix.prefix::text
    WHERE resource.client_id = {}
        AND resource.egress;
    '''

# International Number = anything not above
international_digits = '''
    SELECT DISTINCT product_items.digits
    from resource
        INNER JOIN product_items_resource ON resource.resource_id = product_items_resource.resource_id
        INNER JOIN product_items ON product_items_resource.item_id = product_items.item_id
        LEFT JOIN jurisdiction_prefix ON left(product_items.digits::text, 6) = jurisdiction_prefix.prefix::text 
                        OR ('1' || left(product_items.digits::text, 6)) = jurisdiction_prefix.prefix::text
    WHERE resource.client_id = {}
        AND resource.egress
        AND jurisdiction_prefix.prefix is null
        AND left(product_items.digits::text, 3) not IN ('800', '888', '877', '866', '855', '844');
    '''

# ORIGINATION LATA SUMMARY REPORT (US LOCAL AND Toll FREE)
US_local_and_toll_free_lata_digits = '''
    SELECT product_items.digits, jurisdiction_prefix.lata
    from resource
        INNER JOIN product_items_resource ON resource.resource_id = product_items_resource.resource_id
        INNER JOIN product_items ON product_items_resource.item_id = product_items.item_id
        INNER JOIN jurisdiction_prefix ON left(product_items.digits::text, 6) = jurisdiction_prefix.prefix::text 
                        OR ('1' || left(product_items.digits::text, 6)) = jurisdiction_prefix.prefix::text
    WHERE resource.client_id = {}
        AND resource.egress;
    '''

# ORIGINATION LATA SUMMARY REPORT (International DIDs)
international_lata_digits = '''
    SELECT DISTINCT product_items.digits, jurisdiction_name
    from resource
        INNER JOIN product_items_resource ON resource.resource_id = product_items_resource.resource_id
        INNER JOIN product_items ON product_items_resource.item_id = product_items.item_id
        LEFT JOIN jurisdiction_prefix ON left(product_items.digits::text, 6) = jurisdiction_prefix.prefix::text 
                        OR ('1' || left(product_items.digits::text, 6)) = jurisdiction_prefix.prefix::text
    WHERE resource.client_id = {}
        AND resource.egress
        AND jurisdiction_prefix.prefix is null
        AND left(product_items.digits::text, 3) not IN ('800', '888', '877', '866', '855', '844');
    '''

# Country code
country_code = '''
    SELECT code, name
    FROM code
    WHERE code @> '{}'
        AND code_deck_id = {}
    ORDER BY CODE ASC
    LIMIT 1;
    '''

# Jurisdiction prefix
us_jurisdiction_prefix = '''
    SELECT prefix, jurisdiction_name, lata
    FROM jurisdiction_prefix
    WHERE prefix @> '{}';
    '''
